/*

Data structures for I/O of polygonal models containing vector field information

Created and Modified by Guoning Chen

*/

#ifndef __VFPLY_IO_H__
#define __VFPLY_IO_H__

typedef struct Vertex_io {
public:
  float x,y,z;
  int angle_deficit;
  float vx, vy, vz;
  void *other_props;       /* other properties */
} Vertex_io;

typedef struct Face_io {
  unsigned char nverts;    /* number of vertex indices in list */
  int *verts;              /* vertex index list */
  void *other_props;       /* other properties */
} Face_io;

char *elem_names[] = { /* list of the kinds of elements in the user's object */
  "vertex", "face"
};

//PlyProperty vert_props[] = { /* list of property information for a vertex */
//  {"x", Float64, Float64, offsetof(Vertex_io,x), 0, 0, 0, 0},
//  {"y", Float64, Float64, offsetof(Vertex_io,y), 0, 0, 0, 0},
//  {"z", Float64, Float64, offsetof(Vertex_io,z), 0, 0, 0, 0},
//  {"angle_deficit", Int32, Int32, offsetof(Vertex_io,angle_deficit), 0, 0, 0, 0},
//  {"nx", Float64, Float64, offsetof(Vertex_io,vx), 0, 0, 0, 0},
//  {"ny", Float64, Float64, offsetof(Vertex_io,vy), 0, 0, 0, 0},
//  {"nz", Float64, Float64, offsetof(Vertex_io,vz), 0, 0, 0, 0},
//  //{"prob_on_path", Float32, Float32, offsetof(Vertex,prob_on_path), 0, 0, 0, 0},
//};


PlyProperty vert_props[] = { /* list of property information for a vertex */
  {"x", Float32, Float32, offsetof(Vertex_io,x), 0, 0, 0, 0},
  {"y", Float32, Float32, offsetof(Vertex_io,y), 0, 0, 0, 0},
  {"z", Float32, Float32, offsetof(Vertex_io,z), 0, 0, 0, 0},
  {"angle_deficit", Int32, Int32, offsetof(Vertex_io,angle_deficit), 0, 0, 0, 0},
  {"nx", Float32, Float32, offsetof(Vertex_io,vx), 0, 0, 0, 0},
  {"ny", Float32, Float32, offsetof(Vertex_io,vy), 0, 0, 0, 0},
  {"nz", Float32, Float32, offsetof(Vertex_io,vz), 0, 0, 0, 0},
  //{"prob_on_path", Float32, Float32, offsetof(Vertex,prob_on_path), 0, 0, 0, 0},
};

PlyProperty face_props[] = { /* list of property information for a face */
  {"vertex_indices", Int32, Int32, offsetof(Face_io,verts), 1, Uint8, Uint8, offsetof(Face_io,nverts)},
};


//PlyProperty face_props[] = { /* list of property information for a face */
//  {"vertex_indices", Int32, Int32, offsetof(Face,verts),
//   1, Uint8, Uint8, offsetof(Face,nverts)},
//  {"area", Float32, Float32, offsetof(Face,area), 0, 0, 0, 0},
//};

#endif /* __VFPLY_IO_H__ */
